import string
import secrets

from mongo.get_conn import db_conn

class beer_data:
    """
    This class will allow us to
    interact with our data to interact
    just create a pool_data var
    """
    def __init__(self):
        #db_conn has all the the things
        #already created from here 
        #we can get self.db.real_db etc 
        self.db = db_conn()

    def record_exists(self, date, beer_run_id):
        """
            This function will accept an address
            if it find that address in the database it will return True
            and set set the existing_record variable of the class to the 
            queried record
        """
        query = { "date" : f"{date}", "beer_run_id": f"{beer_run_id}"}
        record = self.db.beer_db.find_one(query)
        if record:
            self.existing_record = record
            return True
        else:
            return False


    def create_re_record(self, beer_run_id, beer_type, sg, date, final_reading=False, comment=""):
        """
            create_re_record creates a whole new record
            takes the required 7 inputs
            1. beer_run_id
            2. beer_type
            3. sg
            4. date
            5. comment(optional)
            It will autogenerate the id string
            this string will be automatically selected
            on view in future
        """
        key = self.create_id()
        insert_record = {
                "_id" : f"{key}",
                "beer_run_id": f"{beer_run_id}",
                "beer_type": f"{beer_type}",
                "sg": f"{sg}",
                "date": f"{date}",
                "final_reading": f"{final_reading}",
                "comment": f"{comment}"

                }
        self.db.beer_db.insert_one(insert_record)

    def update_re_record(self, id, field, value):
        """
            update_re_record
            will update the requested field to value for the
            selected field 
        """
        #TODO: do we need to make this take more than 1 id?

        query = { "_id": f"{id}"}
        update_val = {"$set": {f"{field}": f"{value}" }}
        self.db.beer_db.update_one(query, update_val)

    def create_id(self):
        alphabet = string.ascii_letters + string.digits
        key = ''.join(secrets.choice(alphabet) for _ in range(24))
        return key

